; ShineInHex.inc

include	windows.inc
include	user32.inc
include	kernel32.inc
include	gdi32.inc
include	masm32.inc

includelib	user32.lib
includelib	kernel32.lib
includelib	gdi32.lib
includelib	masm32.lib


CreateClass	Proto
to_UTF8		Proto	:DWORD,:DWORD
DlgFind		Proto	:DWORD,:DWORD,:DWORD,:DWORD
DlgSelect	Proto	:DWORD,:DWORD,:DWORD,:DWORD
ShineInHexInit	Proto
CreateTextTable	Proto

; dword/word/byte ptr
IfNDef	D
D	equ	DWORD PTR
W	equ	WORD PTR
B	equ	BYTE PTR
EndIf

o		equ	offset
CrLf		equ	13,10

SIZEX STRUCT
	cx_ dd ?
	cy_ dd ?
SIZEX ENDS

HEX_DIM struct
	bk_color1   dd ?
	bk_color2   dd ?
	bk_color3   dd ?
	text_color1 dd ?
	text_color2 dd ?
	text_color3 dd ?
	sel_bk_color2    dd ?
	sel_bk_color3    dd ?
	sel_text_color2  dd ?
	sel_text_color3  dd ?
	active_char_bk_color   dd ?
	active_char_text_color dd ?
	rc1 RECT    <?>
	rc2 RECT    <?>
	rc3 RECT    <?>
	sel_rc RECT <?>
	scroll_rc RECT <?>
	main_rc   RECT <?>
	view_lenx  dd ?
	view_leny  dd ?
	vscrollpos dd ?
	byte_nr    dd ?
	_size      dd ?
	_start     dd ? ;offset
	_nMax      dd ?
	font       dd ?
	client_cy  dd ?
	fon_cx     dd ?
	fon_cy     dd ?
	sel_start  dd ?
	sel_end    dd ?
	pointer    dd ?
	hWnd       dd ?
	found_offs dd ?
	checked    dd ?
	timer_direction dd ?
HEX_DIM ends

.const
	HEXM_SETFONT          equ WM_USER+100 ;{wParam-font_number: 0 - Fixedsys, 1 - Courier, 2 - Terminal} {lParam-0}
	HEXM_SETVIEW1COL      equ WM_USER+101 ;{wParam-bk_color}     {lParam-text_color}
	HEXM_SETVIEW2COL      equ WM_USER+102 ;{wParam-bk_color}     {lParam-text_color}
	HEXM_SETVIEW3COL      equ WM_USER+103 ;{wParam-bk_color}     {lParam-text_color}
	HEXM_SETVIEW2SELCOL   equ WM_USER+104 ;{wParam-bk_color}     {lParam-text_color}
	HEXM_SETVIEW3SELCOL   equ WM_USER+105 ;{wParam-bk_color}     {lParam-text_color}
	HEXM_SETPOINTER       equ WM_USER+106 ;{wParam-data pointer} {lParam-data size }
	HEXM_UNSETPOINTER     equ WM_USER+110 ;{wParam-0}            {lParam-0         }
	HEXM_SETOFFSET        equ WM_USER+107 ;{wParam-offset}       {lParam-0         }
	HEXM_SETACTIVECHARCOL equ WM_USER+108 ;{wParam-bk_color}     {lParam-text_color}
	HEXM_SETSEL           equ WM_USER+109 ;{wParam-start_offs}	 {lParam-end_offset}

	WHEEL_DELTA		equ	120
	
.data
	measure_x	db	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",0
	classname	db	"SHINEINHEX",0
;	hex_dm    HEX_DIM <0>
	lf1		LOGFONT <12,8,0,0,400,0,0,0,DEFAULT_CHARSET,0,0,0,0,"Fixedsys">
	lf2		LOGFONT <12,8,0,0,400,0,0,0,DEFAULT_CHARSET,0,0,0,0,"Courier" >
	lf3		LOGFONT <12,8,0,0,400,0,0,0,OEM_CHARSET,    0,0,0,0,"Terminal">
	lf_choose	dd	lf1,lf2,lf3
	IfDef	STATIC_TABLE
	hexlook		db	"00  01  02  03  04  05  06  07  08  09  0A  0B  0C  0D  0E  0F  "
			db	"10  11  12  13  14  15  16  17  18  19  1A  1B  1C  1D  1E  1F  "
			db	"20  21  22  23  24  25  26  27  28  29  2A  2B  2C  2D  2E  2F  "
			db	"30  31  32  33  34  35  36  37  38  39  3A  3B  3C  3D  3E  3F  "
			db	"40  41  42  43  44  45  46  47  48  49  4A  4B  4C  4D  4E  4F  "
			db	"50  51  52  53  54  55  56  57  58  59  5A  5B  5C  5D  5E  5F  "
			db	"60  61  62  63  64  65  66  67  68  69  6A  6B  6C  6D  6E  6F  "
			db	"70  71  72  73  74  75  76  77  78  79  7A  7B  7C  7D  7E  7F  "
			db	"80  81  82  83  84  85  86  87  88  89  8A  8B  8C  8D  8E  8F  "
			db	"90  91  92  93  94  95  96  97  98  99  9A  9B  9C  9D  9E  9F  "
			db	"A0  A1  A2  A3  A4  A5  A6  A7  A8  A9  AA  AB  AC  AD  AE  AF  "
			db	"B0  B1  B2  B3  B4  B5  B6  B7  B8  B9  BA  BB  BC  BD  BE  BF  "
			db	"C0  C1  C2  C3  C4  C5  C6  C7  C8  C9  CA  CB  CC  CD  CE  CF  "
			db	"D0  D1  D2  D3  D4  D5  D6  D7  D8  D9  DA  DB  DC  DD  DE  DF  "
			db	"E0  E1  E2  E3  E4  E5  E6  E7  E8  E9  EA  EB  EC  ED  EE  EF  "
			db	"F0  F1  F2  F3  F4  F5  F6  F7  F8  F9  FA  FB  FC  FD  FE  FF  "
	hexspace	db	"                                                                "
			db	"                                                                "
			db	"                                                                "
	hex_nl		db	13,10,0
	EndIf
	menu_copy_text db	"Copy &text",0
	menu_copy_hex  db	"Copy &hex",0
	menu_find      db	"Find...",0
	menu_select    db	"Select...",0
	error_hex      db	"Need one more number",0
	hex_byte       db 0
	hex_set1       dd 1
	hex_set2       dd 1
	hex_clip_copy  dd 0
	hex_clip_point dd 0
	ALIGN 4
.data?
	hInstance	dd	?
	hex_popup	dd	?
	hex_dm		HEX_DIM	<>
	align	4
	IfNDef	STATIC_TABLE
	hexlook		db	16*16*4 dup (?)
	hexspace	db	3*16*4 dup (?)
	hex_nl		dd	?
	EndIf
	align	4
