.586
.model flat,stdcall
option casemap:none

include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include masm32.inc
include comdlg32.inc
include Shell32.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib masm32.lib
includelib comdlg32.lib
includelib Shell32.lib

CrLf		equ	13,10
o		equ	offset

OFN_FLAGS_OPEN	equ	OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY

; Resource IDs
IDM_OPEN	equ	10002
IDM_SAVE	equ	10003
IDM_EXIT	equ	10004
IDM_SETTINGS	equ	10007

include Test_ShineInHex.Inc

WinMain    proto :DWORD,:DWORD,:DWORD,:DWORD
ChooseProc proto :DWORD,:DWORD,:DWORD,:DWORD

.data
	sih    db "ShineInHex.dll",0
	sihc   db "SHINEINHEX",0

	colors dd 0ffffffh,0ff8080h,0ffffffh,0800000h,0ffffffh,0008000h,0ff8080h,0c0ffc0h,0808000h,0ffffffh,00000ffh,0ffffffh

.data?
	sihh   dd ?
	fname  dd ?
	fsize  dd ?
	hmem   dd ?
	font   dd ?
	col_st dd ?
	col_br dd ?
; Open File Name
OpenFN		OPENFILENAME	<>
szFileIn	db	400h dup(?)	; 1KB

.const
	HEXM_SETFONT          equ WM_USER+100 ;wParam-font_nr {0,1,2} lParam-0
	HEXM_SETVIEW1COL      equ WM_USER+101 ;wParam-bk_color lParam-text_color
	HEXM_SETVIEW2COL      equ WM_USER+102 ;wParam-bk_color lParam-text_color
	HEXM_SETVIEW3COL      equ WM_USER+103 ;wParam-bk_color lParam-text_color
	HEXM_SETVIEW2SELCOL   equ WM_USER+104 ;wParam-bk_color lParam-text_color
	HEXM_SETVIEW3SELCOL   equ WM_USER+105 ;wParam-bk_color lParam-text_color
	HEXM_SETPOINTER       equ WM_USER+106 ;wParam-data pointer lParam-data size
	HEXM_SETOFFSET        equ WM_USER+107 ;wParam-offset lParam-0
	HEXM_SETACTIVECHARCOL equ WM_USER+108 ;wParam-bk_color lParam-text_color
.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	libm dd ?
.code


; ---------------------------------------------------------------------------


Start:
	invoke GetModuleHandle, NULL
	mov    hInstance, eax
	invoke GetCommandLine
	mov    CommandLine, eax
	invoke LoadLibrary, ADDR sih
	mov    libm, eax
	invoke WinMain, hInstance, 0, CommandLine, SW_SHOWDEFAULT
	invoke FreeLibrary, libm
	invoke ExitProcess, eax
	ret

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc  :WNDCLASSEX
	LOCAL msg :MSG
	LOCAL hwnd:HWND
	
	mov    wc.cbSize, SIZEOF WNDCLASSEX
	mov    wc.style,  0
	mov    wc.lpfnWndProc, OFFSET WndProc
	mov    wc.cbClsExtra, 0
	mov    wc.cbWndExtra, 0
	push   hInstance
	pop    wc.hInstance
	mov    wc.hbrBackground, 0
	mov    wc.lpszMenuName,  10000
	mov    wc.lpszClassName, OFFSET sih
	
	invoke LoadIcon, 0, IDI_APPLICATION
	mov    wc.hIcon,   eax
	mov    wc.hIconSm, eax
	
	invoke LoadCursor, 0, IDC_ARROW
	mov    wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,WS_EX_ACCEPTFILES, ADDR sih, ADDR sih,\
			WS_OVERLAPPEDWINDOW, 100,100,400,400, 0, 0, hInst, 0
	mov    hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage,  ADDR msg
	.ENDW
	
	mov     eax, msg.wParam
	ret
WinMain endp

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL file:DWORD
	LOCAL pointer:DWORD

	mov    eax, uMsg
	.if eax==WM_CREATE
		invoke CreateWindowEx, 0, offset sihc, 0, WS_CHILD+WS_VISIBLE+WS_VSCROLL+WS_CLIPCHILDREN+WS_CLIPSIBLINGS, 10, 10, 200, 300, hWin, 0, hInstance, 0
		mov    sihh, eax
		
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		.if eax==IDM_OPEN
			mov	edx,o OpenFN
			push	edx	; for GetOpenFileName call
			ZeroMemD	edx,sizeof OPENFILENAME
			InitOFN	[edx],o szFileIn,sizeof szFileIn,OFN_FLAGS_OPEN,o szSelectFile,o szOpenFilter,hWin
			call	GetOpenFileName
			ifz	@@Done
			@@OpenFile:
			m2m	fname,o szFileIn
			.if	hmem
				invoke GlobalUnlock, hmem
				invoke GlobalFree,   hmem
			.endif
			mov    file,fopen(fname)
			invoke GetFileSize, file, 0
			mov    fsize, eax
			invoke GlobalAlloc, GMEM_FIXED, eax
			mov    hmem, eax
			invoke GlobalLock, hmem
			mov    pointer, eax
			mov    ecx, fread(file, eax, fsize)
			fclose(file)
			invoke SendMessage, sihh, HEXM_SETPOINTER, pointer, fsize
		.elseif eax==IDM_SAVE
				mov    file,fopenW(fname)
				mov    ecx, fwrite(file, hmem, fsize)
				fclose(file)
		.elseif eax==IDM_EXIT
			invoke SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, 0
		.elseif eax==IDM_SETTINGS
			invoke DialogBoxParam, hInstance, 2000, hWin, ADDR ChooseProc, 0
		.endif
		
	;.elseif eax==WM_ACTIVATE
	;	invoke SendMessage, sihh, WM_SETFOCUS, 0, 0
		
	.elseif eax==WM_SIZE
		mov    eax,lParam
		mov    edx,eax
		shr    eax,16
		and    edx,0ffffh
		invoke MoveWindow, sihh, 0, 0, edx, eax, TRUE

	.elseif eax==WM_ERASEBKGND
		mov    eax, 1
		ret
	.ElseIf eax == WM_DROPFILES
		mov	eax, wParam
		push	eax	; hDrop
		invoke	DragQueryFile,eax,0,o szFileIn,sizeof szFileIn
		call	DragFinish	;,hDrop
		invoke	GetFileAttributes,addr szFileIn
		iff	@@Done
		cmp	eax,FILE_ATTRIBUTE_DIRECTORY
		jne	@@OpenFile
	.elseif eax==WM_DESTROY
		.if hmem!=0
			invoke GlobalUnlock, hmem
			invoke GlobalFree,   hmem
		.endif
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc, hWin, uMsg, wParam, lParam		
		ret
	.endif
	
	xor	eax,eax
	@@Done:
	ret
WndProc endp

ChooseProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL hex_offs[16]:BYTE
	
	mov    eax, uMsg
	.if eax==WM_INITDIALOG
		invoke SendDlgItemMessage, hWin, 2002, CB_ADDSTRING, 0, CADD("0 - Fixedsys")
		invoke SendDlgItemMessage, hWin, 2002, CB_ADDSTRING, 0, CADD("1 - Courier")
		invoke SendDlgItemMessage, hWin, 2002, CB_ADDSTRING, 0, CADD("2 - Terminal")
		
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View1 bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View1 text color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View2 bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View2 text color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View3 bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View3 text color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View2 selection bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View2 selection text color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View3 selection bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View3 selection text color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Active char bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Active char text color")
		
		invoke SendDlgItemMessage, hWin, 2002, CB_SETCURSEL, font, 0
		invoke SendDlgItemMessage, hWin, 2008, CB_SETCURSEL, 0, 0
		
		mov    col_br, FUNC(CreateSolidBrush, dword ptr [colors+0])
		mov    col_st, FUNC(GetDlgItem, hWin, 2004)
		
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		mov    ecx, eax
		shr    eax, 16
		.if eax==CBN_SELCHANGE
			and    ecx, 0ffffh
			.if ecx==2002
				mov    font, FUNC(SendDlgItemMessage, hWin, ecx, CB_GETCURSEL, 0, 0) 
			.elseif ecx==2008
				invoke DeleteObject, col_br
				invoke SendDlgItemMessage, hWin, 2008, CB_GETCURSEL, 0, 0
				mov    col_br, FUNC(CreateSolidBrush, dword ptr [colors+eax*4])
				invoke InvalidateRect, col_st, 0, 0
			.endif
		.endif
		.if wParam==2004
			invoke ColorDialog, hWin, hInstance, 0
			.if eax!=0
				push   eax
				invoke DeleteObject, col_br
				invoke SendDlgItemMessage, hWin, 2008, CB_GETCURSEL, 0, 0
				pop    ecx
				mov    dword ptr [colors+eax*4], ecx
				mov    col_br, FUNC(CreateSolidBrush, ecx)
				invoke InvalidateRect, col_st, 0, 0
			.endif
		.elseif wParam==2005 || wParam==2007
			invoke SendMessage, sihh, HEXM_SETFONT, font, 0
			invoke SendMessage, sihh, HEXM_SETVIEW1COL,      dword ptr [colors+ 0], dword ptr [colors+ 4]
			invoke SendMessage, sihh, HEXM_SETVIEW2COL,      dword ptr [colors+ 8], dword ptr [colors+12]
			invoke SendMessage, sihh, HEXM_SETVIEW3COL,      dword ptr [colors+16], dword ptr [colors+20]
			invoke SendMessage, sihh, HEXM_SETVIEW2SELCOL,   dword ptr [colors+24], dword ptr [colors+28]
			invoke SendMessage, sihh, HEXM_SETVIEW3SELCOL,   dword ptr [colors+32], dword ptr [colors+36]
			invoke SendMessage, sihh, HEXM_SETACTIVECHARCOL, dword ptr [colors+40], dword ptr [colors+44]
			invoke SendDlgItemMessage, hWin, 2010, WM_GETTEXT, 9, ADDR hex_offs
			invoke htodw, ADDR hex_offs
			mov    ecx, eax
			invoke SendMessage, sihh, HEXM_SETOFFSET, ecx, 0
			.if wParam==2005
				invoke EndDialog, hWin, 1
			.endif
		.elseif wParam==2006
			invoke EndDialog, hWin, 2
		.endif
		
	.elseif eax==WM_CTLCOLORSTATIC
		mov    eax, col_st
		.if lParam==eax
			mov eax, col_br
		.else
			xor eax, eax
		.endif
		ret
		
	.elseif eax==WM_CLOSE
		invoke DeleteObject, col_br
		invoke EndDialog, hWin, 0
		
	.else
		mov    eax,FALSE
		ret
	.endif
	mov    eax,TRUE
	ret
ChooseProc endp

End	Start
